﻿Option Explicit On
Option Strict Off

Imports Game_PluginAPI
Imports System.Xml.Serialization
Imports System.IO
Imports System.Runtime.InteropServices
Imports System.IO.MemoryMappedFiles
Imports System.Math
Imports System.Threading

Public Class GamePlugin
    Implements IPlugin_Game
    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '///                            SimTools Plugin - Edit the Setting below to provide support for your favorite game!                             ///
    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////// 
    '/// Per Game Settings - Change for Each Game ///
    '////////////////////////////////////////////////
    Private Const _PluginAuthorsName As String = "value1, yobuddy"
    Private Const _GameName As String = "FSX_P3D" 'GameName (Must Be Unique!) - the displayed Name.
    Private Const _ProcessName As String = "fsx,Prepar3D" 'Process_Name without the (".exe") for this game
    Private Const _Port As String = "4123"  'Your Sending/Recieving UDP Port for this game
    Private Const _RequiresPatchingPath As Boolean = True 'do we need the game exe path for patching? (must be True if _RequiresSecondCheck = True)
    Private Const _RequiresSecondCheck As Boolean = False 'Used when games have the same _ProcessName. (all plugins with the same _ProcessName must use this!)
    Private Const _PluginOptions As String = "" 'Reserved For Future Use - No Change Needed 
    '////////////////////////////////////////////////
    '///           Memory Map Variables           ///
    '////////////////////////////////////////////////
    Private Const _Enable_MemoryMap As Boolean = False 'Is a MemoryMap file Required for this game?
    Private Const _MMF_Name As String = "" 'Set if using a Memory Map File - EXAMPLE("$gtr2$")
    '////////////////////////////////////////////////
    '///           MemoryHook Variables           ///
    '////////////////////////////////////////////////   
    Private Const _Enable_MemoryHook As Boolean = True 'Is a Memory Hook Required for this game? 
    Private Const _MemHook_Roll As UInteger = 10 'Not Used = 0
    Private Const _MemHook_Pitch As UInteger = 10
    Private Const _MemHook_Heave As UInteger = 10
    Private Const _MemHook_Yaw As UInteger = 10
    Private Const _MemHook_Sway As UInteger = 10
    Private Const _MemHook_Surge As UInteger = 10
    Private Const _MemHook_Extra1 As UInteger = 10
    Private Const _MemHook_Extra2 As UInteger = 10
    Private Const _MemHook_Extra3 As UInteger = 10
    '////////////////////////////////////////////////
    '///    DOFs Used for Output for this Game    ///
    '////////////////////////////////////////////////
    Private Const _DOF_Support_Roll As Boolean = True
    Private Const _DOF_Support_Pitch As Boolean = True
    Private Const _DOF_Support_Heave As Boolean = True
    Private Const _DOF_Support_Yaw As Boolean = True
    Private Const _DOF_Support_Sway As Boolean = True
    Private Const _DOF_Support_Surge As Boolean = True
    Private Const _DOF_Support_Extra1 As String = "Roll_Speed" 'Blank = False
    Private Const _DOF_Support_Extra2 As String = "Pitch_Speed" '"" = Not Used
    Private Const _DOF_Support_Extra3 As String = "Yaw_Speed" 'ADD THE FORCE NAME HERE
    '/////////////////////////////////////////////////
    '///       GameDash - Dash Board Support       ///
    '/////////////////////////////////////////////////
    Private Const _Enable_DashBoard As Boolean = True  'Enable the DashBoard Output System?
    'EXAMPLES OF DASH OUTPUT (all variables are strings) - 20 DASH OUTPUTS MAX!!!
    'Use the Variables with either Process_PacketRecieved, Process_MemoryHook or Process_MemoryMap.
    'Variable = (*Action, Value) as String - (The *Action variable can be anything)
    'Basic Dash Support should include at the minimum -  SPEED, RPM and GEAR
    'Dash_1_Output = "Speed," & OUTPUT_VALUE_HERE.ToString
    'Dash_2_Output = "Rpm," & OUTPUT_VALUE_HERE.ToString
    'Dash_2_Output = "Gear," & OUTPUT_VALUE_HERE.ToString
    '...
    'Dash_20_Output = "Engine Temp," & OUTPUT_VALUE_HERE.ToString
    '/////////////////////////////////////////////////
    '///           GameVibe Support              ///
    '/////////////////////////////////////////////////
    Private Const _Enable_GameVibe As Boolean = False 'Enable the GameVibe Output System?
    'EXAMPLES OF GameVibe OUTPUT (all variables are strings) - 9 GameVibe OUTPUTS MAX!!!
    'Use the Variables with either Process_PacketRecieved, Process_MemoryHook or Process_MemoryMap.
    'Variable = (*Action, Value) as String - (The *Action" variable can ONLY be: Rpm, Heave, Sway, Surge, FR, FL, RR, RL, Turbo)
    'Basic GameVibe Support should include at the minimum -  Rpm
    'Vibe_1_Output = "Rpm," & OUTPUT_VALUE_HERE.ToString
    'Vibe_2_Output = "Heave," & OUTPUT_VALUE_HERE.ToString
    'Vibe_3_Output = "Sway," & OUTPUT_VALUE_HERE.ToString
    'Vibe_4_Output = "Surge," & OUTPUT_VALUE_HERE.ToString
    '...
    'Vibe_9_Output = "Gear Shift," & OUTPUT_VALUE_HERE.ToString
    '/////////////////////////////////////////////////

    Public i_Request As UInt32 = 0
    Public i_Get As UInt32 = 0
    Public Fehlermeldung As String

    'Used by GameManager when the Game Starts.
    Public Sub GameStart() Implements IPlugin_Game.GameStart
        'DO SOMETHING HERE AT GAME START!
        SURFACE_TYPE_String(0) = "Concrete"
        SURFACE_TYPE_String(1) = "Grass"
        SURFACE_TYPE_String(2) = "Water"
        SURFACE_TYPE_String(3) = "Grass_bumpy"
        SURFACE_TYPE_String(4) = "Asphalt"
        SURFACE_TYPE_String(5) = "Short_grass"
        SURFACE_TYPE_String(6) = "Long_grass"
        SURFACE_TYPE_String(7) = "Hard_turf"
        SURFACE_TYPE_String(8) = "Snow"
        SURFACE_TYPE_String(9) = "Ice"
        SURFACE_TYPE_String(10) = "Urban"
        SURFACE_TYPE_String(11) = "Forest"
        SURFACE_TYPE_String(12) = "Dirt"
        SURFACE_TYPE_String(13) = "Coral"
        SURFACE_TYPE_String(14) = "Gravel"
        SURFACE_TYPE_String(15) = "Oil_treated"
        SURFACE_TYPE_String(16) = "Steel_mats"
        SURFACE_TYPE_String(17) = "Bituminus"
        SURFACE_TYPE_String(18) = "Brick"
        SURFACE_TYPE_String(19) = "Macadam"
        SURFACE_TYPE_String(20) = "Planks"
        SURFACE_TYPE_String(21) = "Sand"
        SURFACE_TYPE_String(22) = "Shale"
        SURFACE_TYPE_String(23) = "Tarmac"
        SURFACE_TYPE_String(24) = "Wright_flyer_track"
    End Sub

    'Used by GameManager when the Game Stops.
    Public Sub GameStop() Implements IPlugin_Game.GameEnd
        'DO SOMETHING HERE AT GAME STOP!
        SimConnected = False
    End Sub

    'Used by GameManager to Process a MemoryHook.
    Public Sub Process_MemoryHook() Implements IPlugin_Game.Process_MemoryHook
        'DO SOMETHING HERE AT GAME START!  




        If Not (SimConnected) Then
            Try
                hr = SimConnect_Open(hSimConnect, "SimTools", 0, 0, 0, -1)
                If hr = S_OK Then
                    SimConnected = True
                End If
            Catch ex As Exception
                Dash_16_Output = TimeOfDay & " Open ," & ex.Message
                SimConnected = False
                Exit Sub
            End Try
            Try
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "PLANE PITCH DEGREES", "degree", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 0)
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "PLANE BANK DEGREES", "degree", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 1)
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "PLANE HEADING DEGREES TRUE", "degree", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 2)
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "ACCELERATION BODY Z", "Gforce", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 3)
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "ACCELERATION BODY X", "Gforce", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 4)
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "ACCELERATION BODY Y", "Gforce", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 5)

                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "ROTATION VELOCITY BODY Z", "degree per second", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 6)
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "ROTATION VELOCITY BODY X", "degree per second", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 7)
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "ROTATION VELOCITY BODY Y", "degree per second", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 8)

                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "GROUND VELOCITY", "Knots", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 9)
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "GENERAL ENG RPM:1", "Rpm", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 10)
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "PROP RPM:1", "Rpm", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 11)

                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "GENERAL ENG RPM:2", "Rpm", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 12)
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "PROP RPM:2", "Rpm", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 13)

                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "GENERAL ENG RPM:3", "Rpm", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 14)
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "PROP RPM:3", "Rpm", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 15)

                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "GENERAL ENG RPM:4", "Rpm", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 16)
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "PROP RPM:4", "Rpm", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 17)

                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "STALL WARNING", "Bool", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 18)
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "OVERSPEED WARNING", "Bool", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 19)
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "GEAR POSITION", "Enum", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 20)
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "LIGHT ON STATES", "Mask", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 21)
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "SURFACE TYPE", "Enum", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 22)
                hr = SimConnect_AddToDataDefinition(hSimConnect, DEFINITION_1, "SIM ON GROUND", "Bool", SIMCONNECT_DATATYPE.SIMCONNECT_DATATYPE_FLOAT64, 0, 23)

            Catch ex As Exception
                Dash_16_Output = TimeOfDay & " AddToDataDefinition ," & ex.Message
                SimConnected = False
                Exit Sub
            End Try
        Else
            Try
                hr = SimConnect_RequestDataOnSimObjectType(hSimConnect, DATA_REQUEST_ID.DATA_REQUEST_POSITION, 0, 0, 0)
                Dim pData As IntPtr
                Dim pcbData As IntPtr

                hr = SimConnect_GetNextDispatch(hSimConnect, pData, pcbData)
                If hr = S_OK Then
                    Dim Recv As SIMCONNECT_RECV = Marshal.PtrToStructure(pData, GetType(SIMCONNECT_RECV))
                    If Recv.dwID = SIMCONNECT_RECV_ID.SIMCONNECT_RECV_ID_SIMOBJECT_DATA_BYTYPE Then
                        pData = pData + Marshal.SizeOf(Recv)
                        Dim RecvData As SIMCONNECT_RECV_SIMOBJECT_DATA = Marshal.PtrToStructure(pData, GetType(SIMCONNECT_RECV_SIMOBJECT_DATA))
                        If RecvData.dwRequestID = DATA_REQUEST_ID.DATA_REQUEST_POSITION Then
                            pData = pData + Marshal.SizeOf(RecvData) - 4
                            SimData = Marshal.PtrToStructure(pData, GetType(SimDataStructure))
                        End If
                    End If
                End If


            Catch ex As Exception
                Dash_16_Output = TimeOfDay & " GetNextDispatch ," & ex.Message
                SimConnected = False
                Exit Sub
            End Try
            Try
                Roll_MemHook = SimData.roll
                Pitch_MemHook = SimData.pitch
                Heave_MemHook = SimData.heave
                Yaw_MemHook = SimData.yaw - 180.0
                Sway_MemHook = SimData.sway
                Surge_MemHook = SimData.surge
                Extra1_MemHook = SimData.roll_speed
                Extra2_MemHook = SimData.pitch_speed
                Extra3_MemHook = SimData.yaw_speed

                Dash_1_Output = "Speed [knots]," & Int(SimData.speed * 10.0 + 0.5) / 10.0
                Dash_2_Output = "Eng1 RPM," & Int(SimData.Eng_RPM_1 + 0.5)
                Dash_3_Output = "Prop1 RPM," & Int(SimData.Prop_RPM_1 + 0.5)
                Dash_4_Output = "Eng2 RPM," & Int(SimData.Eng_RPM_2 + 0.5)
                Dash_5_Output = "Prop2 RPM," & Int(SimData.Prop_RPM_2 + 0.5)
                Dash_6_Output = "Eng3 RPM," & Int(SimData.Eng_RPM_3 + 0.5)
                Dash_7_Output = "Prop3 RPM," & Int(SimData.Prop_RPM_3 + 0.5)
                Dash_8_Output = "Eng4 RPM," & Int(SimData.Eng_RPM_4 + 0.5)
                Dash_9_Output = "Prop4 RPM," & Int(SimData.Prop_RPM_4 + 0.5)


                Dash_10_Output = "Stall Warning," & SimData.stall
                Dash_11_Output = "Overspeed Warning," & SimData.overspeed
                Dash_12_Output = "Langing Gear State," & SimData.gear
                Dash_13_Output = "Light Indicator," & SimData.light
                Dash_14_Output = "Surface," & SURFACE_TYPE_String(SimData.surface)
                Dash_15_Output = "On ground," & SimData.onGround
            Catch ex As Exception
                Dash_16_Output = TimeOfDay & " Data ," & ex.Message
                SimConnected = False
                Exit Sub
            End Try
        End If
        Dash_16_Output = TimeOfDay & ",ok"

    End Sub

    'Used by GameManager to Process a MemoryMap.
    Public Sub Process_MemoryMap() Implements IPlugin_Game.Process_MemoryMap
        'DO SOMETHING HERE AT GAME START!

    End Sub


    'Used by GameEngine to Process Incoming UDP Packets.
    Public Sub Process_PacketRecieved(Text As String) Implements IPlugin_Game.Process_PacketRecieved
        Input_Data = CType(DeSerializeString(Text), GenericOutput)
        'Get Proper Data out of UDP Packet
        With Input_Data
            Roll_Output = (._Roll)
            Pitch_Output = (._Pitch)
            Heave_Output = (._Heave)
            Yaw_Output = (._Yaw)
            Sway_Output = (._Sway)
            Surge_Output = (._Surge)
            Extra1_Output = (._Extra1)
            Extra2_Output = (._Extra2)
            Extra3_Output = (._Extra3)
        End With
    End Sub

    'Used by GameManager to Patch a Game.
    Public Function PatchGame(ByVal MyPath As String, ByVal MyIp As String) As Boolean Implements IPlugin_Game.PatchGame
        'Change as Needed
        UnPatch(MyPath)
        Dim TargetPath As String = Directory.GetCurrentDirectory()
        Try
            System.IO.File.Copy(MyPath & "SimConnect.dll", TargetPath & "\SimConnect.dll", True)
        Catch ex As Exception
            If Right(ex.Message, 26) = "SimConnect.dll' is denied." Then
                MsgBox("Run GameManager in Admin mode when patching!" & vbCrLf & "If it doesn't work, copy the file 'SimConnect.dll' from the FSW installation directory" & vbCrLf & "'..\Steam\SteamApps\common\FSW\'" & vbCrLf & "to the installation directory of SimTools.")
            Else
                MsgBox(ex.Message)
            End If
            Return False
        End Try
        MsgBox("Patch installed!", MsgBoxStyle.OkOnly, "Patching info")
        Return True
    End Function

    'Used by GameManager to UnPatch a Game.
    Public Sub UnPatchGame(MyPath As String) Implements IPlugin_Game.UnPatchGame
        'Change as Needed
        'UnPatch(MyPath)
        MsgBox("Patch Uninstalled!", MsgBoxStyle.OkOnly, "Patching info")
    End Sub

    'Used by GameManager to UnPatch a Game.
    Private Sub UnPatch(MyPath As String)

    End Sub

    'Tells the User where to patch the game 
    Public Sub PatchPathInfo() Implements IPlugin_Game.PatchPathInfo
        'Tell the User where to patch the game 
        'MsgBox("Please Select FSW's Installation Directory.", MsgBoxStyle.OkOnly, "Patching info")
    End Sub

    'Used by GameManager to Validate a Path befors Patching.
    Public Function ValidatePatchPath(MyPath As String) As Boolean Implements IPlugin_Game.ValidatePatchPath
        'insert a simple validation of the patching path - let the user know he got it right
        Return System.IO.File.Exists(MyPath & "\FSW.exe")
    End Function


    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '///                                                 PLACE EXTRA NEEDED CODE/FUNCTIONS HERE                                                     ///
    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#Region "///// - EXTRA CODE/FUNCTIONS USED FOR THIS PLUGIN - /////"


    'Declarations for SimConnect

    <DllImport("Microsoft.FlightSimulator.SimConnect.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Shared Function SimConnect_AddToDataDefinition(
                                                  ByVal hSimConnect As Int32,
                                                  ByVal DefineID As Int32,
                                                  ByVal DatumName As String,
                                                  ByVal UnitsName As String,
                                                  ByVal DatumType As Int32,
                                                  Optional ByVal fEpsilon As Single = 0,
                                                  Optional ByVal DatumID As Int32 = 0) As Int32
    End Function

    <DllImport("Microsoft.FlightSimulator.SimConnect.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Shared Function SimConnect_Open(ByRef hSimConnect As UInt32, ByVal AppName As String, ByVal hWnd As UInt32, ByVal UserEventWin32 As UInt32, ByVal hEventHandle As UInt32, ByVal ConfigIndex As Int32) As UInt32
    End Function

    <DllImport("Microsoft.FlightSimulator.SimConnect.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Shared Function SimConnect_GetNextDispatch(ByVal hSimConnect As Int32, ByRef ppData As IntPtr, ByRef pcbData As IntPtr) As Int32
    End Function

    <DllImport("Microsoft.FlightSimulator.SimConnect.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Shared Function SimConnect_RequestDataOnSimObject(ByVal hSimConnect As Int32,
                                                      ByVal SIMCONNECT_DATA_REQUEST_ID As Int32,
                                                      ByVal SIMCONNECT_DATA_DEFINITION_ID As Int32,
                                                      ByVal SIMCONNECT_OBJECT_ID As Int32,
                                                      ByVal SIMCONNECT_DATA_REQUEST_FLAG As Int32,
                                                      ByVal origin As Int32,
                                                      ByVal interval As Int32,
                                                      ByVal limit As Int32) As Int32
    End Function

    <DllImport("Microsoft.FlightSimulator.SimConnect.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Shared Function SimConnect_RequestDataOnSimObjectType _
      (ByVal hSimConnect As UInt32,
       ByVal RequestID As Int32,
       ByVal DefineID As UInt32,
       ByVal dwRadiusMeters As UInt32,
       ByVal ObjectType As UInt32) As UInt32
    End Function

    <DllImport("Microsoft.FlightSimulator.SimConnect.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Shared Function SimConnect_Close(ByVal hSimConnect As Int32) As Int32
    End Function

    'Constants and Variables for SimConnect

    Const S_OK = 0
    Const DEFINITION_1 = 0
    Const radToDeg = 57.2957795130823 '45 / Atan(1.0)
    Const fps2Tog = 3.28083989501 / 9.80665

    Enum SIMCONNECT_DATATYPE
        SIMCONNECT_DATATYPE_INVALID        ' invalid data type
        SIMCONNECT_DATATYPE_INT32          ' 32-bit integer number
        SIMCONNECT_DATATYPE_INT64          ' 64-bit integer number
        SIMCONNECT_DATATYPE_FLOAT32        ' 32-bit floating-point number (float)
        SIMCONNECT_DATATYPE_FLOAT64        ' 64-bit floating-point number (double)
        SIMCONNECT_DATATYPE_STRING8        ' 8-byte string
        SIMCONNECT_DATATYPE_STRING32       ' 32-byte string
        SIMCONNECT_DATATYPE_STRING64       ' 64-byte string
        SIMCONNECT_DATATYPE_STRING128      ' 128-byte string
        SIMCONNECT_DATATYPE_STRING256      ' 256-byte string
        SIMCONNECT_DATATYPE_STRING260      ' 260-byte string
        SIMCONNECT_DATATYPE_STRINGV        ' variable-length string
        SIMCONNECT_DATATYPE_INITPOSITION   ' see SIMCONNECT_DATA_INITPOSITION
        SIMCONNECT_DATATYPE_MARKERSTATE    ' see SIMCONNECT_DATA_MARKERSTATE
        SIMCONNECT_DATATYPE_WAYPOINT       ' see SIMCONNECT_DATA_WAYPOINT
        SIMCONNECT_DATATYPE_LATLONALT      ' see SIMCONNECT_DATA_LATLONALT
        SIMCONNECT_DATATYPE_XYZ            ' see SIMCONNECT_DATA_XYZ
        SIMCONNECT_DATATYPE_MAX             ' enum limit
    End Enum

    Enum SIMCONNECT_RECV_ID
        SIMCONNECT_RECV_ID_NULL
        SIMCONNECT_RECV_ID_EXCEPTION
        SIMCONNECT_RECV_ID_OPEN
        SIMCONNECT_RECV_ID_QUIT
        SIMCONNECT_RECV_ID_EVENT
        SIMCONNECT_RECV_ID_EVENT_OBJECT_ADDREMOVE
        SIMCONNECT_RECV_ID_EVENT_FILENAME
        SIMCONNECT_RECV_ID_EVENT_FRAME
        SIMCONNECT_RECV_ID_SIMOBJECT_DATA
        SIMCONNECT_RECV_ID_SIMOBJECT_DATA_BYTYPE
        SIMCONNECT_RECV_ID_WEATHER_OBSERVATION
        SIMCONNECT_RECV_ID_CLOUD_STATE
        SIMCONNECT_RECV_ID_ASSIGNED_OBJECT_ID
        SIMCONNECT_RECV_ID_RESERVED_KEY
        SIMCONNECT_RECV_ID_CUSTOM_ACTION
        SIMCONNECT_RECV_ID_SYSTEM_STATE
        SIMCONNECT_RECV_ID_CLIENT_DATA
    End Enum

    Enum SURFACE_TYPE
        Concrete 'Beton
        Grass 'Gras
        Water 'Wasser
        Grass_bumpy 'Gras_uneben
        Asphalt 'Asphalt
        Short_grass 'Kurz_gras
        Long_grass 'Lang_gras
        Hard_turf 'Harter_Rasen
        Snow 'Schnee
        Ice 'Eis
        Urban 'städtisch
        Forest 'Wald
        Dirt 'Schmutz
        Coral 'Koralle
        Gravel 'Kies
        Oil_treated 'Öl_behandelt
        Steel_mats 'Stahl_Matten
        Bituminus 'Bituminus
        Brick 'Ziegelstein
        Macadam 'Macadam
        Planks 'Dielen
        Sand 'Sand
        Shale 'Schiefer
        Tarmac 'Asphalt
        Wright_flyer_track 'Wright_Flyer_Spur
    End Enum

    Public SURFACE_TYPE_String(24) As String


    Enum DATA_REQUEST_ID
        DATA_REQUEST_POSITION
    End Enum

    Public hr As Int32
    Public hSimConnect As Int32
    Public RequestID As Int32
    Public SimData As SimDataStructure
    Public SimConnected As Boolean = False



    'SimConnect Functions
    Function GetNextDispatch() As Int32
        ' this function returns the dwRequestID field of SIMCONNECT_RECV_SIMOBJECT_DATA, if applicable
        ' otherwise -1
        Try
            Dim pData As IntPtr
            Dim pcbData As IntPtr

            GetNextDispatch = -1
            hr = SimConnect_GetNextDispatch(hSimConnect, pData, pcbData)
            If hr = S_OK Then
                Dim Recv As SIMCONNECT_RECV = Marshal.PtrToStructure(pData, GetType(SIMCONNECT_RECV))
                If Recv.dwID = SIMCONNECT_RECV_ID.SIMCONNECT_RECV_ID_SIMOBJECT_DATA_BYTYPE Then
                    pData = pData + Marshal.SizeOf(Recv)
                    Dim RecvData As SIMCONNECT_RECV_SIMOBJECT_DATA = Marshal.PtrToStructure(pData, GetType(SIMCONNECT_RECV_SIMOBJECT_DATA))
                    GetNextDispatch = RecvData.dwRequestID
                    If RecvData.dwRequestID = DATA_REQUEST_ID.DATA_REQUEST_POSITION Then
                        pData = pData + Marshal.SizeOf(RecvData) - 4
                        SimData = Marshal.PtrToStructure(pData, GetType(SimDataStructure))
                    End If
                End If
            End If
        Catch ex As Exception
        End Try
    End Function

    'SimConncet Structures

    <StructLayout(LayoutKind.Sequential)>
    Structure SIMCONNECT_RECV
        Dim dwSize As Int32
        Dim dwVersion As Int32
        Dim dwID As Int32
    End Structure

    Structure SIMCONNECT_RECV_EXCEPTION
        Dim dwException As Int32
        Dim dwSendID As Int32
        Dim dwIndex As Int32
    End Structure

    Structure SIMCONNECT_RECV_OPEN
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=256)>
        Dim szApplicationName As String
        Dim dwApplicationVersionMajor As Int32
        Dim dwApplicationVersionMinor As Int32
        Dim dwApplicationBuildMajor As Int32
        Dim dwApplicationBuildMinor As Int32
        Dim dwSimConnectVersionMajor As Int32
        Dim dwSimConnectVersionMinor As Int32
        Dim dwSimConnectBuildMajor As Int32
        Dim dwSimConnectBuildMinor As Int32
        Dim dwReserved1 As Int32
        Dim dwReserved2 As Int32
    End Structure

    Structure SIMCONNECT_RECV_SIMOBJECT_DATA
        Dim dwRequestID As Int32
        Dim dwObjectID As Int32
        Dim dwDefineID As Int32
        Dim dwFlags As Int32
        Dim dwentrynumber As Int32
        Dim dwoutof As Int32
        Dim dwDefineCount As Int32
        Dim dwData As Int32
    End Structure

    <StructLayout(LayoutKind.Sequential)>
    Structure SimDataStructure
        Public pitch As Double
        Public roll As Double
        Public yaw As Double
        Public surge As Double
        Public sway As Double
        Public heave As Double

        Public roll_speed As Double
        Public pitch_speed As Double
        Public yaw_speed As Double

        Public speed As Double
        Public Eng_RPM_1 As Double
        Public Prop_RPM_1 As Double
        Public Eng_RPM_2 As Double
        Public Prop_RPM_2 As Double
        Public Eng_RPM_3 As Double
        Public Prop_RPM_3 As Double
        Public Eng_RPM_4 As Double
        Public Prop_RPM_4 As Double

        Public stall As Double
        Public overspeed As Double
        Public gear As Double
        Public light As Double
        Public surface As Double
        Public onGround As Double
    End Structure


    'DeSerialize
    Public Function DeSerializeString(InputString As String) As Object
        On Error Resume Next
        Dim xml_serializer As New XmlSerializer(GetType(GenericOutput))
        Dim string_reader As New StringReader(InputString)
        Dim DeserializedOutput As GenericOutput = DirectCast(xml_serializer.Deserialize(string_reader), GenericOutput)
        string_reader.Close()
        Return DeserializedOutput
    End Function

    Private Input_Data As New GenericOutput

    'Generic In/Output structure
    Public Structure GenericOutput
        Public _Roll As Double
        Public _Pitch As Double
        Public _Heave As Double
        Public _Yaw As Double
        Public _Sway As Double
        Public _Surge As Double
        Public _Extra1 As Double
        Public _Extra2 As Double
        Public _Extra3 As Double
    End Structure



#End Region


    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '///                                                        DO NOT EDIT BELOW HERE!!!                                                           ///
    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#Region "///// BUILT IN METHODS FOR SIMTOOLS - DO Not CHANGE /////"
    'Output Dash Vars
    Public Dash_1_Output As String = ""
    Public Dash_2_Output As String = ""
    Public Dash_3_Output As String = ""
    Public Dash_4_Output As String = ""
    Public Dash_5_Output As String = ""
    Public Dash_6_Output As String = ""
    Public Dash_7_Output As String = ""
    Public Dash_8_Output As String = ""
    Public Dash_9_Output As String = ""
    Public Dash_10_Output As String = ""
    Public Dash_11_Output As String = ""
    Public Dash_12_Output As String = ""
    Public Dash_13_Output As String = ""
    Public Dash_14_Output As String = ""
    Public Dash_15_Output As String = ""
    Public Dash_16_Output As String = ""
    Public Dash_17_Output As String = ""
    Public Dash_18_Output As String = ""
    Public Dash_19_Output As String = ""
    Public Dash_20_Output As String = ""

    'Output Vars
    Public Roll_Output As Double = 0
    Public Pitch_Output As Double = 0
    Public Heave_Output As Double = 0
    Public Yaw_Output As Double = 0
    Public Sway_Output As Double = 0
    Public Surge_Output As Double = 0
    Public Extra1_Output As Double = 0
    Public Extra2_Output As Double = 0
    Public Extra3_Output As Double = 0

    'MemHook Vars
    Public Roll_MemHook As Double = 0
    Public Pitch_MemHook As Double = 0
    Public Heave_MemHook As Double = 0
    Public Yaw_MemHook As Double = 0
    Public Sway_MemHook As Double = 0
    Public Surge_MemHook As Double = 0
    Public Extra1_MemHook As Double = 0
    Public Extra2_MemHook As Double = 0
    Public Extra3_MemHook As Double = 0

    'MemMap Vars
    Public Roll_MemMap As Double = 0
    Public Pitch_MemMap As Double = 0
    Public Heave_MemMap As Double = 0
    Public Yaw_MemMap As Double = 0
    Public Sway_MemMap As Double = 0
    Public Surge_MemMap As Double = 0
    Public Extra1_MemMap As Double = 0
    Public Extra2_MemMap As Double = 0
    Public Extra3_MemMap As Double = 0

    'GameVibe Vars
    Public Vibe_1_Output As String = ""
    Public Vibe_2_Output As String = ""
    Public Vibe_3_Output As String = ""
    Public Vibe_4_Output As String = ""
    Public Vibe_5_Output As String = ""
    Public Vibe_6_Output As String = ""
    Public Vibe_7_Output As String = ""
    Public Vibe_8_Output As String = ""
    Public Vibe_9_Output As String = ""

    Public Function Get_PluginVersion() As String Implements IPlugin_Game.Get_PluginVersion
        Return System.Reflection.Assembly.GetExecutingAssembly.GetName.Version.ToString
    End Function

    Public Function GetDOFsUsed() As String Implements IPlugin_Game.GetDOFsUsed
        'Return DOF's Used (Roll,Pitch,Heave,Yaw,Sway,Surge)
        Return (_DOF_Support_Roll.ToString & "," & _DOF_Support_Pitch.ToString & "," & _DOF_Support_Heave.ToString & "," & _DOF_Support_Yaw.ToString & "," & _DOF_Support_Sway.ToString & "," & _DOF_Support_Surge.ToString & "," & _DOF_Support_Extra1.ToString & "," & _DOF_Support_Extra2.ToString & "," & _DOF_Support_Extra3.ToString)
    End Function

    Public Sub ResetDOFVars() Implements IPlugin_Game.ResetDOFVars
        Roll_Output = 0
        Pitch_Output = 0
        Heave_Output = 0
        Yaw_Output = 0
        Sway_Output = 0
        Surge_Output = 0
        Extra1_Output = 0
        Extra2_Output = 0
        Extra3_Output = 0
    End Sub

    Public Sub ResetMapVars() Implements IPlugin_Game.ResetMapVars
        Roll_MemMap = 0
        Pitch_MemMap = 0
        Heave_MemMap = 0
        Yaw_MemMap = 0
        Sway_MemMap = 0
        Surge_MemMap = 0
        Extra1_MemMap = 0
        Extra2_MemMap = 0
        Extra3_MemMap = 0
    End Sub

    Public Sub ResetHookVars() Implements IPlugin_Game.ResetHookVars
        Roll_MemHook = 0
        Pitch_MemHook = 0
        Heave_MemHook = 0
        Yaw_MemHook = 0
        Sway_MemHook = 0
        Surge_MemHook = 0
        Extra1_MemHook = 0
        Extra2_MemHook = 0
        Extra3_MemHook = 0
    End Sub

    Public Sub ResetDashVars() Implements IPlugin_Game.ResetDashVars
        Dash_1_Output = ""
        Dash_2_Output = ""
        Dash_3_Output = ""
        Dash_4_Output = ""
        Dash_5_Output = ""
        Dash_6_Output = ""
        Dash_7_Output = ""
        Dash_8_Output = ""
        Dash_9_Output = ""
        Dash_10_Output = ""
        Dash_11_Output = ""
        Dash_12_Output = ""
        Dash_13_Output = ""
        Dash_14_Output = ""
        Dash_15_Output = ""
        Dash_16_Output = ""
        Dash_17_Output = ""
        Dash_18_Output = ""
        Dash_19_Output = ""
        Dash_20_Output = ""
    End Sub

    Public Sub ResetVibeVars() Implements IPlugin_Game.ResetVibeVars
        Vibe_1_Output = ""
        Vibe_2_Output = ""
        Vibe_3_Output = ""
        Vibe_4_Output = ""
        Vibe_5_Output = ""
        Vibe_6_Output = ""
        Vibe_7_Output = ""
        Vibe_8_Output = ""
        Vibe_9_Output = ""
    End Sub

    Public ReadOnly Property PluginAuthorsName() As String Implements IPlugin_Game.PluginAuthorsName
        Get
            Return _PluginAuthorsName
        End Get
    End Property

    Public ReadOnly Property Name() As String Implements IPlugin_Game.GameName
        Get
            Return _GameName
        End Get
    End Property

    Public ReadOnly Property ProcessName() As String Implements IPlugin_Game.ProcessName
        Get
            Return _ProcessName
        End Get
    End Property

    Public ReadOnly Property Port() As String Implements IPlugin_Game.Port
        Get
            Return _Port
        End Get
    End Property

    Public ReadOnly Property Enable_MemoryMap() As Boolean Implements IPlugin_Game.Enable_MemoryMap
        Get
            Return _Enable_MemoryMap
        End Get
    End Property

    Public ReadOnly Property Enable_MemoryHook() As Boolean Implements IPlugin_Game.Enable_MemoryHook
        Get
            Return _Enable_MemoryHook
        End Get
    End Property

    Public ReadOnly Property RequiresPatchingPath() As Boolean Implements IPlugin_Game.RequiresPatchingPath
        Get
            Return _RequiresPatchingPath
        End Get
    End Property

    Public ReadOnly Property RequiresSecondCheck() As Boolean Implements IPlugin_Game.RequiresSecondCheck
        Get
            Return _RequiresSecondCheck
        End Get
    End Property

    Public ReadOnly Property Enable_DashBoard() As Boolean Implements IPlugin_Game.Enable_DashBoard
        Get
            Return _Enable_DashBoard
        End Get
    End Property

    Public ReadOnly Property Enable_GameVibe() As Boolean Implements IPlugin_Game.Enable_GameVibe
        Get
            Return _Enable_GameVibe
        End Get
    End Property

    Public Function Get_RollOutput() As Double Implements IPlugin_Game.Get_RollOutput
        Return Roll_Output
    End Function

    Public Function Get_PitchOutput() As Double Implements IPlugin_Game.Get_PitchOutput
        Return Pitch_Output
    End Function

    Public Function Get_HeaveOutput() As Double Implements IPlugin_Game.Get_HeaveOutput
        Return Heave_Output
    End Function

    Public Function Get_YawOutput() As Double Implements IPlugin_Game.Get_YawOutput
        Return Yaw_Output
    End Function

    Public Function Get_SwayOutput() As Double Implements IPlugin_Game.Get_SwayOutput
        Return Sway_Output
    End Function

    Public Function Get_SurgeOutput() As Double Implements IPlugin_Game.Get_SurgeOutput
        Return Surge_Output
    End Function

    Public Function Get_Extra1Output() As Double Implements IPlugin_Game.Get_Extra1Output
        Return Extra1_Output
    End Function

    Public Function Get_Extra2Output() As Double Implements IPlugin_Game.Get_Extra2Output
        Return Extra2_Output
    End Function

    Public Function Get_Extra3Output() As Double Implements IPlugin_Game.Get_Extra3Output
        Return Extra3_Output
    End Function

    Public Function Get_Dash_1_Output() As String Implements IPlugin_Game.Get_Dash1_Output
        Return Dash_1_Output
    End Function

    Public Function Get_Dash_2_Output() As String Implements IPlugin_Game.Get_Dash2_Output
        Return Dash_2_Output
    End Function

    Public Function Get_Dash_3_Output() As String Implements IPlugin_Game.Get_Dash3_Output
        Return Dash_3_Output
    End Function

    Public Function Get_Dash_4_Output() As String Implements IPlugin_Game.Get_Dash4_Output
        Return Dash_4_Output
    End Function

    Public Function Get_Dash_5_Output() As String Implements IPlugin_Game.Get_Dash5_Output
        Return Dash_5_Output
    End Function

    Public Function Get_Dash_6_Output() As String Implements IPlugin_Game.Get_Dash6_Output
        Return Dash_6_Output
    End Function

    Public Function Get_Dash_7_Output() As String Implements IPlugin_Game.Get_Dash7_Output
        Return Dash_7_Output
    End Function

    Public Function Get_Dash_8_Output() As String Implements IPlugin_Game.Get_Dash8_Output
        Return Dash_8_Output
    End Function

    Public Function Get_Dash_9_Output() As String Implements IPlugin_Game.Get_Dash9_Output
        Return Dash_9_Output
    End Function

    Public Function Get_Dash_10_Output() As String Implements IPlugin_Game.Get_Dash10_Output
        Return Dash_10_Output
    End Function

    Public Function Get_Dash_11_Output() As String Implements IPlugin_Game.Get_Dash11_Output
        Return Dash_11_Output
    End Function

    Public Function Get_Dash_12_Output() As String Implements IPlugin_Game.Get_Dash12_Output
        Return Dash_12_Output
    End Function

    Public Function Get_Dash_13_Output() As String Implements IPlugin_Game.Get_Dash13_Output
        Return Dash_13_Output
    End Function

    Public Function Get_Dash_14_Output() As String Implements IPlugin_Game.Get_Dash14_Output
        Return Dash_14_Output
    End Function

    Public Function Get_Dash_15_Output() As String Implements IPlugin_Game.Get_Dash15_Output
        Return Dash_15_Output
    End Function

    Public Function Get_Dash_16_Output() As String Implements IPlugin_Game.Get_Dash16_Output
        Return Dash_16_Output
    End Function

    Public Function Get_Dash_17_Output() As String Implements IPlugin_Game.Get_Dash17_Output
        Return Dash_17_Output
    End Function

    Public Function Get_Dash_18_Output() As String Implements IPlugin_Game.Get_Dash18_Output
        Return Dash_18_Output
    End Function

    Public Function Get_Dash_19_Output() As String Implements IPlugin_Game.Get_Dash19_Output
        Return Dash_19_Output
    End Function

    Public Function Get_Dash_20_Output() As String Implements IPlugin_Game.Get_Dash20_Output
        Return Dash_20_Output
    End Function

    Public Function Get_RollMemHook() As Double Implements IPlugin_Game.Get_RollMemHook
        Return Roll_MemHook
    End Function

    Public Function Get_PitchMemHook() As Double Implements IPlugin_Game.Get_PitchMemHook
        Return Pitch_MemHook
    End Function

    Public Function Get_HeaveMemHook() As Double Implements IPlugin_Game.Get_HeaveMemHook
        Return Heave_MemHook
    End Function

    Public Function Get_YawMemHook() As Double Implements IPlugin_Game.Get_YawMemHook
        Return Yaw_MemHook
    End Function

    Public Function Get_SwayMemHook() As Double Implements IPlugin_Game.Get_SwayMemHook
        Return Sway_MemHook
    End Function

    Public Function Get_SurgeMemHook() As Double Implements IPlugin_Game.Get_SurgeMemHook
        Return Surge_MemHook
    End Function

    Public Function Get_Extra1MemHook() As Double Implements IPlugin_Game.Get_Extra1MemHook
        Return Extra1_MemHook
    End Function

    Public Function Get_Extra2MemHook() As Double Implements IPlugin_Game.Get_Extra2MemHook
        Return Extra2_MemHook
    End Function

    Public Function Get_Extra3MemHook() As Double Implements IPlugin_Game.Get_Extra3MemHook
        Return Extra3_MemHook
    End Function

    Public Function Get_RollMemMap() As Double Implements IPlugin_Game.Get_RollMemMap
        Return Roll_MemMap
    End Function

    Public Function Get_PitchMemMap() As Double Implements IPlugin_Game.Get_PitchMemMap
        Return Pitch_MemMap
    End Function

    Public Function Get_HeaveMemMap() As Double Implements IPlugin_Game.Get_HeaveMemMap
        Return Heave_MemMap
    End Function

    Public Function Get_YawMemMap() As Double Implements IPlugin_Game.Get_YawMemMap
        Return Yaw_MemMap
    End Function

    Public Function Get_SwayMemMap() As Double Implements IPlugin_Game.Get_SwayMemMap
        Return Sway_MemMap
    End Function

    Public Function Get_SurgeMemMap() As Double Implements IPlugin_Game.Get_SurgeMemMap
        Return Surge_MemMap
    End Function

    Public Function Get_Extra1MemMap() As Double Implements IPlugin_Game.Get_Extra1MemMap
        Return Extra1_MemMap
    End Function

    Public Function Get_Extra2MemMap() As Double Implements IPlugin_Game.Get_Extra2MemMap
        Return Extra2_MemMap
    End Function

    Public Function Get_Extra3MemMap() As Double Implements IPlugin_Game.Get_Extra3MemMap
        Return Extra3_MemMap
    End Function

    Public Function Get_Vibe1_Output() As String Implements IPlugin_Game.Get_Vibe1_Output
        Return Vibe_1_Output
    End Function

    Public Function Get_Vibe2_Output() As String Implements IPlugin_Game.Get_Vibe2_Output
        Return Vibe_2_Output
    End Function

    Public Function Get_Vibe3_Output() As String Implements IPlugin_Game.Get_Vibe3_Output
        Return Vibe_3_Output
    End Function

    Public Function Get_Vibe4_Output() As String Implements IPlugin_Game.Get_Vibe4_Output
        Return Vibe_4_Output
    End Function

    Public Function Get_Vibe5_Output() As String Implements IPlugin_Game.Get_Vibe5_Output
        Return Vibe_5_Output
    End Function

    Public Function Get_Vibe6_Output() As String Implements IPlugin_Game.Get_Vibe6_Output
        Return Vibe_6_Output
    End Function

    Public Function Get_Vibe7_Output() As String Implements IPlugin_Game.Get_Vibe7_Output
        Return Vibe_7_Output
    End Function

    Public Function Get_Vibe8_Output() As String Implements IPlugin_Game.Get_Vibe8_Output
        Return Vibe_8_Output
    End Function

    Public Function Get_Vibe9_Output() As String Implements IPlugin_Game.Get_Vibe9_Output
        Return Vibe_9_Output
    End Function

    Public ReadOnly Property PluginOptions() As String Implements IPlugin_Game.PluginOptions
        Get
            Return _PluginOptions
        End Get
    End Property
#End Region
End Class